unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Excel2000, OleServer, DB, ADODB,ActiveX;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label1: TLabel;
    Button3: TButton;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    ADOConnection1: TADOConnection;
    ADOQuery1: TADOQuery;
    ExcelApplication1: TExcelApplication;
    ExcelChart1: TExcelChart;
    ExcelWorksheet1: TExcelWorksheet;
    ExcelWorkbook1: TExcelWorkbook;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    Button6: TButton;
    Button11: TButton;
    GroupBox2: TGroupBox;
    Memo1: TMemo;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    Panel2: TPanel;
    Button4: TButton;
    Button5: TButton;
    Panel3: TPanel;
    Label10: TLabel;
    Label7: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    Label6: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Edit4: TEdit;
    StaticText1: TStaticText;
    ComboBox1: TComboBox;
    Edit5: TEdit;
    ComboBox2: TComboBox;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    ButtonDeleteField: TButton;
    ButtonUpField: TButton;
    ButtonDownField: TButton;
    ComboBox4: TComboBox;
    Edit6: TEdit;
    Button10: TButton;
    ListView1: TListView;
    FontDialog1: TFontDialog;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Edit7: TEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    ComboBox3: TComboBox;
    Label9: TLabel;
    CheckBox6: TCheckBox;
    Label13: TLabel;
    ComboBox5: TComboBox;
    Label14: TLabel;
    ComboBox6: TComboBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    function SelectFont(var SF:string):Boolean;
    procedure CreateExcel(chart:boolean);
    procedure SetFont(SF:string);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure ButtonDeleteFieldClick(Sender: TObject);
    procedure ButtonUpFieldClick(Sender: TObject);
    procedure ButtonDownFieldClick(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    first_in,ass:boolean;
    row_sele:integer;
    lcid: integer;
  end;

var
  Form1: TForm1;

implementation

uses ADOConEd;

{$R *.dfm}


function TForm1.SelectFont(var SF:string):Boolean;
var i:integer;
begin
   if not (SF='') then
   begin
      i:=pos(',',SF);
      if i>0 then
         FontDialog1.Font.Name:=copy(SF,1,i-1);
      FontDialog1.Font.Style:=[];
      if pos('u',SF)>0 then
         FontDialog1.Font.Style:=FontDialog1.Font.Style+[fsUnderline];
      if pos('',SF)>0 then
         FontDialog1.Font.Style:=FontDialog1.Font.Style+[fsBold];
      if pos('',SF)>0 then
         FontDialog1.Font.Style:=FontDialog1.Font.Style+[fsItalic];
      while (i>0) do
      begin
         SF:=copy(SF,i+1,length(SF)-i);
         i:=pos(',',SF);
      end;
      i:=pos('r',SF);
      if i>0 then
         FontDialog1.Font.Size:=strtoint(copy(SF,1,i-1));
   end;
   SF:='';
   if FontDialog1.Execute then
   begin
      SF:=FontDialog1.Font.Name;
      if fsUnderline in FontDialog1.Font.Style then
         SF:=SF+',u';
      if fsBold in FontDialog1.Font.Style then
         SF:=SF+',';
      if fsItalic in FontDialog1.Font.Style then
         SF:=SF+',';
      SF:=SF+','+floattostr(FontDialog1.Font.Size)+'r';
      Result:=True;
   end else
      Result:=False;
end;

procedure TForm1.CreateExcel(chart:boolean);
var i,j,co:integer;
    _Template,_SourceData,_TableDestination,_TableName,_Readdata,
    _RowFields,_ColumnFields:Olevariant;
    _Cell1,_Cell2:OleVariant;
    ChType,SheetType,_Type,_Legendkey: OleVariant;
begin
   lcid := GetUserDefaultLCID;
   try
      ExcelApplication1.Connect;
      ExcelApplication1.Visible[lcid]:=True;
      _Template:=xlWBATWorksheet;
      ExcelWorkbook1.ConnectTo(ExcelApplication1.Workbooks.Add(_Template, lcid));
      ExcelWorksheet1.ConnectTo(ExcelWorkbook1.Worksheets[1] as _Worksheet);
      ExcelWorksheet1.Name := '';
   except
      showmessage('LksWExcel');
      exit;
   end;
   co:=0;
   for i:=0 to ListView1.Items.Count-1 do
   begin
      if ListView1.Items[i].SubItems[0]='O' then
      begin
         _Cell1:=chr(65+co)+'1';
         ExcelWorksheet1.Range[_Cell1,_Cell1].Value:=ListView1.Items[i].SubItems[1];
         ExcelWorksheet1.Range[_Cell1,_Cell1].Select;
         case ComboBox2.Items.IndexOf(ListView1.Items[i].SubItems[1]) of
            0:(ExcelApplication1.Selection[Lcid] as Range).HorizontalAlignment:=xlHAlignLeft;
            1:(ExcelApplication1.Selection[Lcid] as Range).HorizontalAlignment:=xlHAlignCenter;
            2:(ExcelApplication1.Selection[Lcid] as Range).HorizontalAlignment:=xlHAlignRight;
            3:(ExcelApplication1.Selection[Lcid] as Range).HorizontalAlignment:=xlHAlignDistributed;
            4:(ExcelApplication1.Selection[Lcid] as Range).HorizontalAlignment:=xlHAlignFill;
            5:(ExcelApplication1.Selection[Lcid] as Range).HorizontalAlignment:=xlHAlignGeneral;
            6:(ExcelApplication1.Selection[Lcid] as Range).HorizontalAlignment:=xlHAlignCenterAcrossSelection;
            7:(ExcelApplication1.Selection[Lcid] as Range).HorizontalAlignment:=xlHAlignJustify;
         else
         end;
         Setfont(ListView1.Items[i].SubItems[3]);
         co:=co+1;
      end;
   end;
   ADOQuery1.Active:=True;
   j:=2;
   while not Adoquery1.Eof do
   begin
      co:=0;
      for i:=0 to ListView1.Items.Count-1 do
      begin
         if ListView1.Items[i].SubItems[0]='O' then
         begin
            _cell1:=chr(65+co)+inttostr(j);
            ExcelWorksheet1.Range[_Cell1,_Cell1].Value:=ADOquery1.fieldbyname(ListView1.Items[i].Caption).Value;
            ExcelWorksheet1.Range[_Cell1,_Cell1].Select;
            case ComboBox2.Items.IndexOf(ListView1.Items[i].SubItems[4]) of
               0:(ExcelApplication1.Selection[Lcid] as Range).HorizontalAlignment:=xlHAlignLeft;
               1:(ExcelApplication1.Selection[Lcid] as Range).HorizontalAlignment:=xlHAlignCenter;
               2:(ExcelApplication1.Selection[Lcid] as Range).HorizontalAlignment:=xlHAlignRight;
               3:(ExcelApplication1.Selection[Lcid] as Range).HorizontalAlignment:=xlHAlignDistributed;
               4:(ExcelApplication1.Selection[Lcid] as Range).HorizontalAlignment:=xlHAlignFill;
               5:(ExcelApplication1.Selection[Lcid] as Range).HorizontalAlignment:=xlHAlignGeneral;
               6:(ExcelApplication1.Selection[Lcid] as Range).HorizontalAlignment:=xlHAlignCenterAcrossSelection;
               7:(ExcelApplication1.Selection[Lcid] as Range).HorizontalAlignment:=xlHAlignJustify;
            else
            end;
            Setfont(ListView1.Items[i].SubItems[5]);
            co:=co+1;
         end;
      end;
      Adoquery1.Next;
      j:=j+1;
   end;
   ADOQuery1.Active:=false;
   //̾Ae
   _cell2:='A1';
   ExcelWorksheet1.Range[_Cell2,_Cell1].Select;
   (ExcelApplication1.Selection[Lcid] as Range).Columns.AutoFit;
   if chart then
   begin
      SheetType := TOleEnum(xlChart);  // cast to avoid compiler range warnings
      ExcelChart1.ConnectTo(ExcelWorkbook1.Sheets.Add(EmptyParam, EmptyParam, 1, SheetType, lcid) as _Chart);
      ExcelChart1.Name := 'Chart';
      case ComboBox5.Items.IndexOf(ComboBox5.Text) of
         0:ExcelChart1.ChartType := TOleEnum(xlColumnClustered);
         1:ExcelChart1.ChartType := TOleEnum(xlPie);
         2:ExcelChart1.ChartType := TOleEnum(xlLine);
      else
         begin
            showmessage(']wӹϧ');
            exit;
         end;
      end;
{ϧΪ
  xlColumnClustered = $00000033;
  xlColumnStacked = $00000034;
  xlColumnStacked100 = $00000035;
  xl3DColumnClustered = $00000036;
  xl3DColumnStacked = $00000037;
  xl3DColumnStacked100 = $00000038;
  xlBarClustered = $00000039;
  xlBarStacked = $0000003A;
  xlBarStacked100 = $0000003B;
  xl3DBarClustered = $0000003C;
  xl3DBarStacked = $0000003D;
  xl3DBarStacked100 = $0000003E;
  xlLineStacked = $0000003F;
  xlLineStacked100 = $00000040;
  xlLineMarkers = $00000041;
  xlLineMarkersStacked = $00000042;
  xlLineMarkersStacked100 = $00000043;
  xlPieOfPie = $00000044;
  xlPieExploded = $00000045;
  xl3DPieExploded = $00000046;
  xlBarOfPie = $00000047;
  xlXYScatterSmooth = $00000048;
  xlXYScatterSmoothNoMarkers = $00000049;
  xlXYScatterLines = $0000004A;
  xlXYScatterLinesNoMarkers = $0000004B;
  xlAreaStacked = $0000004C;
  xlAreaStacked100 = $0000004D;
  xl3DAreaStacked = $0000004E;
  xl3DAreaStacked100 = $0000004F;
  xlDoughnutExploded = $00000050;
  xlRadarMarkers = $00000051;
  xlRadarFilled = $00000052;
  xlSurface = $00000053;
  xlSurfaceWireframe = $00000054;
  xlSurfaceTopView = $00000055;
  xlSurfaceTopViewWireframe = $00000056;
  xlBubble = $0000000F;
  xlBubble3DEffect = $00000057;
  xlStockHLC = $00000058;
  xlStockOHLC = $00000059;
  xlStockVHLC = $0000005A;
  xlStockVOHLC = $0000005B;
  xlCylinderColClustered = $0000005C;
  xlCylinderColStacked = $0000005D;
  xlCylinderColStacked100 = $0000005E;
  xlCylinderBarClustered = $0000005F;
  xlCylinderBarStacked = $00000060;
  xlCylinderBarStacked100 = $00000061;
  xlCylinderCol = $00000062;
  xlConeColClustered = $00000063;
  xlConeColStacked = $00000064;
  xlConeColStacked100 = $00000065;
  xlConeBarClustered = $00000066;
  xlConeBarStacked = $00000067;
  xlConeBarStacked100 = $00000068;
  xlConeCol = $00000069;
  xlPyramidColClustered = $0000006A;
  xlPyramidColStacked = $0000006B;
  xlPyramidColStacked100 = $0000006C;
  xlPyramidBarClustered = $0000006D;
  xlPyramidBarStacked = $0000006E;
  xlPyramidBarStacked100 = $0000006F;
  xlPyramidCol = $00000070;
  xl3DColumn = $FFFFEFFC;
  xlLine = $00000004;
  xl3DLine = $FFFFEFFB;
  xl3DPie = $FFFFEFFA;
  xlPie = $00000005;
  xlXYScatter = $FFFFEFB7;
  xl3DArea = $FFFFEFFE;
  xlArea = $00000001;
  xlDoughnut = $FFFFEFE8;
  xlRadar = $FFFFEFC9;
}
      ExcelChart1.SetSourceData(ExcelWorksheet1.Range[_Cell2,_Cell1],TOleEnum(xlColumns));  //HC@columnܸ
      if checkbox8.Checked then
      begin
         ExcelChart1.HasTitle[lcid]:=CheckBox8.Checked;
         ExcelChart1.ChartTitle[lcid].Caption:=Edit2.text;
      end;
      _type:=xlCategory;
      (ExcelChart1.Axes(_type,xlPrimary,lcid) as Axis).HasTitle:=CheckBox2.Checked;
      if checkbox2.Checked then
         (ExcelChart1.Axes(_type,xlPrimary,lcid) as Axis).AxisTitle.Caption:=Edit3.text;
      (ExcelChart1.Axes(_type,xlPrimary,lcid) as Axis).HasMajorGridlines:=CheckBox9.checked;
      (ExcelChart1.Axes(_type,xlPrimary,lcid) as Axis).HasMinorGridlines:=CheckBox10.checked;
      _type:=xlValue;
      (ExcelChart1.Axes(_type,xlPrimary,lcid) as Axis).HasTitle:=CheckBox3.Checked;
      if checkBox3.Checked then
      begin
         (ExcelChart1.Axes(_type,xlPrimary,lcid) as Axis).AxisTitle.Caption:=Edit7.text;
         if CheckBox1.Checked then
         begin
            (ExcelChart1.Axes(_type,xlPrimary,lcid) as Axis).AxisTitle.HorizontalAlignment:=xlHAlignCenter;  //ਤ90
            (ExcelChart1.Axes(_type,xlPrimary,lcid) as Axis).AxisTitle.VerticalAlignment := xlCenter;
            (ExcelChart1.Axes(_type,xlPrimary,lcid) as Axis).AxisTitle.Orientation := xlHorizontal;
         end;
      end;
      (ExcelChart1.Axes(_type,xlPrimary,lcid) as Axis).HasMajorGridlines:=CheckBox11.checked;
      (ExcelChart1.Axes(_type,xlPrimary,lcid) as Axis).HasMinorGridlines:=CheckBox12.checked;
      ExcelChart1.HasLegend[lcid]:= CheckBox5.Checked;  //Ϩ
      if CheckBox5.Checked then
      begin
         case ComboBox3.Items.IndexOf(ComboBox3.Text) of
            0:ExcelChart1.Legend[lcid].Position:=xlTop;
            1:ExcelChart1.Legend[lcid].Position:=xlBottom;
            2:ExcelChart1.Legend[lcid].Position:=xlLeft;
            3:ExcelChart1.Legend[lcid].Position:=xlRight;
            4:ExcelChart1.Legend[lcid].Position:=xlCorner;
         else
         end;
      end;
      ExcelChart1.HasDataTable := CheckBox4.Checked;  //ܸƪ
      if CheckBox4.Checked then
         ExcelChart1.DataTable.ShowLegendKey := CheckBox6.Checked;  //ƪϨ
      case ComboBox6.Items.IndexOf(ComboBox6.Text) of  //Ϩ,ҮܹϨ
         0:ExcelChart1.ApplyDataLabels(xlDataLabelsShowNone,false);
         1:ExcelChart1.ApplyDataLabels(xlDataLabelsShowValue,false);
         2:ExcelChart1.ApplyDataLabels(xlDataLabelsShowPercent,false);
         3:begin
              _Legendkey:=CheckBox7.Checked;
              ExcelChart1.ApplyDataLabels(xlDataLabelsShowLabel,_Legendkey);
           end;
         4:begin
              _Legendkey:=CheckBox7.Checked;
              ExcelChart1.ApplyDataLabels(xlDataLabelsShowLabelAndPercent,_Legendkey);
           end;   
         5:ExcelChart1.ApplyDataLabels(xlDataLabelsShowBubbleSizes,false);
      else
      end;
{  Ъ`NݭntXϧ
  xlDataLabelsShowNone = $FFFFEFD2;
  xlDataLabelsShowValue = $00000002;
  xlDataLabelsShowPercent = $00000003;
  xlDataLabelsShowLabel = $00000004;
  xlDataLabelsShowLabelAndPercent = $00000005;
  xlDataLabelsShowBubbleSizes = $00000006;
}
      ExcelChart1.Disconnect;
   end;
   ExcelWorksheet1.Disconnect;
   ExcelWorkbook1.Disconnect;
   ExcelApplication1.Disconnect;
end;


procedure TForm1.SetFont(SF:string);
var s:string;
    i:integer;
begin
   if not (sf='') then
   begin
      s:=sf;
      with (ExcelApplication1.Selection[Lcid] as Range).Font do
      begin
         i:=pos(',',s);
         if i>0 then
            Name:=copy(s,1,i-1);
         if pos('u',s)>0 then
            Underline := 2;
         if pos('',s)>0 then
            Bold := 1;
         if pos('',s)>0 then
            Italic := 1;
         while (i>0) do
         begin
            s:=copy(s,i+1,length(s)-i);
            i:=pos(',',s);
         end;
         i:=pos('r',s);
         if i>0 then
            Size :=strtoint(copy(s,1,i-1));
      end;
   end;
end;


procedure TForm1.Button3Click(Sender: TObject);
begin
   ADOConnection1.Connected:=false;
   ADOConnection1.ConnectionString:=edit1.text;
   if EditConnectionString(ADOConnection1) then
      Edit1.Text:=ADOConnection1.ConnectionString;
end;

procedure TForm1.Button1Click(Sender: TObject);
var s:string;
    f:textfile;
begin
   s:=application.ExeName;
   s:=ChangeFileExt(s,'.txt');
   assignfile(f,s);
   rewrite(f);
   s:=edit1.text;
   writeln(f,s);
   closefile(f);
   Button1.Enabled:=false;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   try
      ADOConnection1.Connected:=false;
      ADOConnection1.ConnectionString:=edit1.text;
      ADOConnection1.Connected:=true;
      Pagecontrol1.ActivePageIndex:=Pagecontrol1.ActivePageIndex+1;
      Form1.Caption:='NExcelChart--'+PageControl1.ActivePage.Caption;
   except
      if not first_in then
         showmessage('Ʈw|~');
      first_in:=false;
   end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
    s:string;
    f:textfile;
begin
   for i:=0 to PageControl1.PageCount-1 do
      PageControl1.Pages[i].TabVisible:=false;
   PageControl1.ActivePageIndex:=0;
   Form1.Caption:='NExcel Chart--'+PageControl1.ActivePage.Caption;
   s:=application.ExeName;
   s:=ChangeFileExt(s,'.txt');
   if Fileexists(s) then
   begin
      assignfile(f,s);
      reset(f);
      readln(f,s);
      edit1.text:=s;
      closefile(f);
      first_in:=true;
      Button2Click(nil);
   end else
      First_in:=false;
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
   Pagecontrol1.ActivePageIndex:=Pagecontrol1.ActivePageIndex-1;
   Form1.Caption:='NExcelChart--'+PageControl1.ActivePage.Caption;
end;

procedure TForm1.Button6Click(Sender: TObject);
var conn:boolean;
    i:integer;
begin
   ADOQuery1.Active:=false;
   try
      ADOQuery1.SQL.Text:=Memo1.Text;
      ADOQuery1.Active:=true;
      Pagecontrol1.ActivePageIndex:=Pagecontrol1.ActivePageIndex+1;
      Form1.Caption:='NExcelChart--'+PageControl1.ActivePage.Caption;
      if ListView1.Items.Count=0 then
      begin
         Button8click(nil);
      end;
   except
      showmessage('SQLyk~');
   end;
end;

procedure TForm1.Button8Click(Sender: TObject);
var i:integer;
begin
   ListView1.Items.Clear;
   for i:=0 to ADOQuery1.FieldCount-1 do
   begin
      With ListView1.Items.Add Do
      Begin
         Caption := ADOQuery1.Fields[i].FieldName;
         subitems.add('O');
         subitems.add(ADOQuery1.Fields[i].FieldName);
         subitems.add('');
         subitems.add('sө,12r');
         if (ADOQuery1.Fields[i].DataType=ftSmallint) or
            (ADOQuery1.Fields[i].DataType=ftInteger) or
            (ADOQuery1.Fields[i].DataType=ftFloat) or
            (ADOQuery1.Fields[i].DataType=ftCurrency) then
            subitems.add('k')
         else
            subitems.add('');
         subitems.add('sө,12r');
      end;
   end;
   Row_sele:=0;
   ListView1.Selected:=ListView1.Items[Row_sele];
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
   Row_sele:=ListView1.Items.Count;
   With ListView1.Items.Add Do
   Begin
      Caption := '';
      subitems.add('O');
      subitems.add('');
      subitems.add('');
      subitems.add('sө,12r');
      subitems.add('');
      subitems.add('sө,12r');
   end;
   ListView1.Selected:=ListView1.Items[Row_sele];
end;

procedure TForm1.ButtonDeleteFieldClick(Sender: TObject);
var i:integer;
begin
   if (ListView1.Items[row_sele].Caption='') then
   begin
      i:=Row_sele;
      ListView1.Items.Delete(row_sele);
      if ListView1.Items.Count>0 then
         if ListView1.Items.Count<=i then
            Row_sele:=ListView1.Items.Count-1
      else
      begin
         ButtonDownField.Enabled:=false;
         Row_sele:=-1;
      end;
   end else
      ListView1.Items[row_sele].SubItems[0]:='';
   ListView1.Selected:=ListView1.Items[Row_sele];
end;

procedure TForm1.ButtonUpFieldClick(Sender: TObject);
var ss:array[1..5] of string;
    Item1,Item2: TListItem;
begin
   Item1:=ListView1.Items[row_sele];
   Item2:=ListView1.Items[row_sele-1];
   ss[1]:=Item1.Caption;
   ss[2]:=Item1.SubItems[0];
   ss[3]:=Item1.SubItems[1];
   ss[4]:=Item1.SubItems[2];
   ss[5]:=Item1.SubItems[3];
   Item1.Caption:=Item2.Caption;
   Item1.SubItems[0]:=Item2.SubItems[0];
   Item1.SubItems[1]:=Item2.SubItems[1];
   Item1.SubItems[2]:=Item2.SubItems[2];
   Item1.SubItems[3]:=Item2.SubItems[3];
   Item2.Caption:=ss[1];
   Item2.SubItems[0]:=ss[2];
   Item2.SubItems[1]:=ss[3];
   Item2.SubItems[2]:=ss[4];
   Item2.SubItems[3]:=ss[5];
   row_sele:=row_sele-1;
   ListView1.Selected:=ListView1.Items[row_sele];
end;

procedure TForm1.ButtonDownFieldClick(Sender: TObject);
var ss:array[1..5] of string;
    Item1,Item2: TListItem;
begin
   Item1:=ListView1.Items[Row_sele];
   Item2:=ListView1.Items[Row_sele+1];
   ss[1]:=Item1.Caption;
   ss[2]:=Item1.SubItems[0];
   ss[3]:=Item1.SubItems[1];
   ss[4]:=Item1.SubItems[2];
   ss[5]:=Item1.SubItems[3];
   Item1.Caption:=Item2.Caption;
   Item1.SubItems[0]:=Item2.SubItems[0];
   Item1.SubItems[1]:=Item2.SubItems[1];
   Item1.SubItems[2]:=Item2.SubItems[2];
   Item1.SubItems[3]:=Item2.SubItems[3];
   Item2.Caption:=ss[1];
   Item2.SubItems[0]:=ss[2];
   Item2.SubItems[1]:=ss[3];
   Item2.SubItems[2]:=ss[4];
   Item2.SubItems[3]:=ss[5];
   Row_sele:=Row_sele+1;
   ListView1.Selected:=ListView1.Items[Row_sele];
end;

procedure TForm1.Button7Click(Sender: TObject);
var s:string;
begin
   s:=Edit4.Text;
   if SelectFont(s) then
      Edit4.Text:=s;
end;

procedure TForm1.Button10Click(Sender: TObject);
var s:string;
begin
   s:=Edit6.Text;
   if SelectFont(s) then
      Edit6.Text:=s;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
   if ass then
      ListView1.Items[Row_sele].SubItems[0]:=ComBobox1.Text;
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
   if ass then
      ListView1.Items[Row_sele].SubItems[2]:=ComBobox2.Text;
end;

procedure TForm1.ComboBox4Change(Sender: TObject);
begin
   if ass then
      ListView1.Items[Row_sele].SubItems[4]:=ComBobox4.Text;
end;

procedure TForm1.Edit4Change(Sender: TObject);
begin
   if ass then
      ListView1.Items[Row_sele].SubItems[3]:=Edit4.Text;
end;

procedure TForm1.Edit6Change(Sender: TObject);
begin
   if ass then
      ListView1.Items[Row_sele].SubItems[5]:=Edit6.Text;
end;

procedure TForm1.ListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
   ass:=false;
   StaticText1.Caption:=Item.Caption;
   Combobox1.Text:=Item.SubItems[0];
   Edit5.Text:=Item.SubItems[1];
   Combobox2.Text:=Item.SubItems[2];
   Edit4.Text:=Item.SubItems[3];
   Combobox4.Text:=Item.SubItems[4];
   Edit6.Text:=Item.SubItems[5];
   Row_sele:=Item.Index;
   ButtonUpField.Enabled:=not(Row_sele<=0);
   ButtonDownField.Enabled:=not (Row_sele=ListView1.Items.Count-1);
   ass:=true;
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
   CreateExcel(False);
end;

procedure TForm1.Button13Click(Sender: TObject);
begin
   Pagecontrol1.ActivePageIndex:=Pagecontrol1.ActivePageIndex-1;
   Form1.Caption:='NExcelChar--'+PageControl1.ActivePage.Caption;
end;

procedure TForm1.Edit5Change(Sender: TObject);
begin
   if ass then
      ListView1.Items[Row_sele].SubItems[1]:=Edit5.Text;
end;

procedure TForm1.Button14Click(Sender: TObject);
begin
   CreateExcel(True);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   if ListView1.Items.Count<2 then
   begin
      showmessage('֩1');
   end else
   begin
      Edit3.Text:=ListView1.Items[0].SubItems[1];
      Edit7.Text:=ListView1.Items[1].SubItems[1];
      Pagecontrol1.ActivePageIndex:=Pagecontrol1.ActivePageIndex+1;
      Form1.Caption:='NExcelChart--'+PageControl1.ActivePage.Caption;
   end;
end;

end.

